<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
class woo2app_api_default_blog 
{
	
	function __construct()
	{
		add_action( 'init',array ( $this , 'wp2appir_regular_all' ));	
		add_filter( 'query_vars', array ( $this , 'wp2appir_query_vars' ));
		add_action( 'parse_request', array( $this , 'wp2appir_parse_request' ));
	}
	function wp2appir_regular_all()
	{
		add_rewrite_rule( 'my-api.php$', 'index.php?setting', 'top' );
		//add_rewrite_rule( 'my-api.php$', 'index.php?check', 'top' );
		//add_rewrite_rule( 'my-api.php$', 'index.php?appost', 'top' );
		add_rewrite_rule( 'my-api.php$', 'index.php?cats', 'top' );
		//add_rewrite_rule( 'my-api.php$', 'index.php?login', 'top' );
	}
	function wp2appir_query_vars($query_vars)
	{
		$query_vars[] = 'setting';
		$query_vars[] = 'check';
		$query_vars[] = 'appost';
		$query_vars[] = 'cats';
		$query_vars[] = 'login';
    	return $query_vars;
	}
	function wp2appir_parse_request(&$wp)
	{
		if ( array_key_exists( 'setting', $wp->query_vars ) ) {
	        $this->setting_webservice();
	        exit();
	    }
	    if ( array_key_exists( 'check', $wp->query_vars ) ) {
	        $this->check_webservice();
	        exit();
    	}
    	if ( array_key_exists( 'appost', $wp->query_vars ) ) {
	        $this->appost_webservice();
	        exit();
    	}
    	if ( array_key_exists( 'cats', $wp->query_vars ) ) {
	        $this->cats_webservice();
	        exit();
    	}
    	if ( array_key_exists( 'login', $wp->query_vars ) ) {
	        $this->login_webservice();
	        exit();
    	}
	    return;
	}
	function setting_webservice()
	{	
		ob_start();
			global $wpdb;
		    $table_name = $wpdb->prefix . 'hami_set';
			$records = $wpdb->get_results("select * from $table_name");
			foreach ($records as $record) {
	                        $array[] = array(
	                                                  'name' => $record->name,
													  'value' => $record->value );
	                    }
			$main_page = $this->get_mainpage();
			$slider = $this->get_slider();
			//$array['app_set']['wp2app_mainpage'] =  $main_page;
			//$array['app_set']['wp2app_slider'] = $slider;
	        ob_clean();
	        //var_dump($main_page);
            echo json_encode(array('app_set' => $array , 'wp2app_mainpage' => $main_page , 'wp2app_slider' => $slider));
	}
	function check_webservice()
	{
		ob_start();
			if(!empty($_GET["in"]))
			{
				global $wpdb;
				$table_appstatic = $wpdb->prefix . 'hami_appstatic';
				$in = $_GET['in'];
				$slashless = stripcslashes($in);
				$url_json = urldecode($slashless);
				$json =  json_decode($url_json);
				
				$time = current_time('mysql');
				$ip = $_SERVER['REMOTE_ADDR'];
				$wpdb->query( $wpdb->prepare("INSERT INTO $table_appstatic 
		       ( apst_time, apst_ip , apst_unifo ) 
			   VALUES ( %s, %s, %s )", $time , $ip , $url_json) );
			   $hrt_lastmf_cat = get_option('hrt_lastmf_cat');
			   $hrt_lastmf_appost = get_option('hrt_lastmf_appost');
			   $hrt_lastmf_appsetting = get_option('hrt_lastmf_appsetting');
			   $hrt_lastmf_cat = strtotime($hrt_lastmf_cat);
			   $hrt_lastmf_appost = strtotime($hrt_lastmf_appost);
			   $hrt_lastmf_appsetting = strtotime($hrt_lastmf_appsetting);
				$array = array(
								'hrt_lastmf_cat' => $hrt_lastmf_cat,
								'hrt_lastmf_appost' => $hrt_lastmf_appost,
								'hrt_lastmf_appsetting' => $hrt_lastmf_appsetting
							  );		
				
ob_clean();
				echo json_encode($array);
				
			}
			else
			{	
				echo "not found page";
			}
			
	}
	function appost_webservice()
	{
ob_start();
			global $wpdb;
			$table_posts = $wpdb->prefix . 'posts';
			$table_appost = $wpdb->prefix . 'hami_appost';
			$data = $wpdb->get_results("select * from $table_appost");
			foreach ($data as $key ) {
				if($key->post_id == -1)
				{
					$array['appost'][] = array(
						'post_id' => (int) $key->post_id,
						'Type' => $key->type,
						'Title' => $key->title,
					    'Metadata' => $key->Metadata,
		         		'order_post' => $key->order_post,
						'Menu' => $key->Menu,
						'icon' => $key->icon
											  );
				}else{
					$record = get_post($key->post_id);
						$recent_author = get_user_by( 'ID', $record->post_author );
						// Get user display name
						$author_display_name = $recent_author->display_name;				
						$id =  $record->ID; 
						$author = $author_display_name;
						$date = $record->post_date;
						$content = $record->post_content;
						$title = $record->post_title;
						$comment_count = $record->comment_count;
						$comment_status = $record->comment_status;
						$order_post = $key->order_post;
						$menu = $key->Menu;
						$icon = $key->icon;
						$type = $key->type;
						$metadata = $key->Metadata;
						$Post_link = get_permalink($record->ID);
					$content = apply_filters("the_content" , $content );
					if ( has_post_thumbnail( $id ) ) {
						$large_image_url = wp_get_attachment_image_src( get_post_thumbnail_id( $id ), 'large' );
						$pic_post = $large_image_url[0];
					}
		            $array['appost'][] = array(
						'post_id' => $id,
						'Post_author' => $author,
					    'Post_date' => $date,
		         		'Post_content' => $content,
						'Post_title' => $title,
						'Comment_count' => $comment_count,
						'Comment_status' => $comment_status,
						'Post_pic' => $pic_post,
						'order_post' => $order_post,
						'Menu' => $menu,
						'icon' => $icon,
						'Type' => $type,
						'Metadata' => $metadata,
						'Post_link' => $Post_link
											  );
	        	}
	            $pic_post = "";
			}//end foreach $data
			
ob_clean();
            echo json_encode($array);
	}
	public function cats_webservice()
	{
ob_start();
			$cat_selected = get_option('wp2app_cats');
			$flag_all = 0;
			$cats1 = explode(",",$cat_selected);
			if($cat_selected != ""){
				foreach ($cats1 as $cat) {
					if($cat == 0){
						$flag_all = 1;
					}
				}
			}else{
				$flag_all = 1 ;
			}
			
			$post_types = get_option("wp2app_post_types");
			$ar = json_decode($post_types,true);
			$array_types = array();
			if ($post_types != "") {
				foreach ($ar as $key) {
					foreach ($key as $k => $v) {
						$array_types[] = $k;		
					}
				}
			}else{
				$array_types = array( 'post' );
			}

			if($cat_selected != "" && $cat_selected != null && !empty($cat_selected) && $flag_all == 0)
			{
				
				$cats1 = explode(",",$cat_selected);
				
				foreach ($cats1 as $cat) {
					  if ($post_types != "") {
							foreach ($ar as $key) {
								foreach ($key as $k => $v) {
									foreach ($v as $x) {
										//if($_post->post_type == $k){
											$record = $this->get_category_hami($cat,OBJECT,'row', $x);
										//}	
									}
								}
							}
						}else{
							$record = $this->get_category_hami($cat,OBJECT,'row',"category");
						}	
				
						$array['cats'][] = array(
		                      'term_id' => $record->term_id,
							  'name' => $record->name,
							  'description' => $record->description,
							  'parent' => $record->parent,
							  'count' => $record->count,
							  );
					
				}
			}else{
				
				if($post_types == ""){
	                /*$args = array(
	                	  'hide_empty' => 0 ,
	                      'numberposts' => $num , 
	                      'post_type' => $array_types,
	                      'tax_query' => array(
	                            array(
	                                'taxonomy' => 'category',
	                                //'field'    => 'term_id',
	                                //'terms'    => $cats1,
	                            ),
	                       ),
	                );  */
					$ar2 = "category";
	            }else{
	                foreach ($ar as $key) {
	                    foreach ($key as $k => $v) {
	                        //$array_types[] = $k;      
	                        $tax_query[] = $v; 
	                    }
	                }
	                $ar1 = array( 'relation' => 'OR' );
	                foreach ($tax_query as $key) {
	                    foreach ($key as $k) {
	                        $ar1[] = array(
	                                'taxonomy' => $k,
	                                //'field'    => 'term_id',
	                                //'terms'    => $cats1,
	                        );
	                        $ar2[] = $k;
	                    }
	                }
	                
	                $args = array(
	                	  'hide_empty' => 0 ,
	                      'numberposts' => $num , 
	                      'post_type' => $array_types,
	                      'tax_query' => $ar1
	                );  
	            
	            }

	            $records = get_terms( $ar2 );

				/*$args1 =	array('hide_empty' => 0 ,
		                'taxonomy' => 'product_cat'
					      );
				$records1 = get_categories($args1);
				
				$args =	array('hide_empty' => 0 ,
		                'taxonomy' => 'category'
					      );
				if (!$records1["errors"]){ 
					$records = array_merge($records1 , get_categories($args) );	
				}else{
					$records = get_categories($args);
				}*/
				
				foreach ($records as $record) {
	                $array['cats'][] = array(
	                          'term_id' => $record->term_id,
							  'name' => $record->name,
							  'description' => $record->description,
							  'parent' => $record->parent,
							  'count' => $record->count,
							  );
	            }
			}
ob_clean();
			echo json_encode($array);
	}
	function login_webservice()
	{
ob_start();
		if(!empty($_GET["in"]))
		{
			$in = $_GET['in'];
			$slashless = stripcslashes($in);
			$url_json = urldecode($slashless);
			$json = (array)  json_decode($url_json);
			$user =  $json["user"];
			$pass =  $json["pass"];	
			if($user != "" && $pass != ""){
				$ok = wp_authenticate ( $user, $pass );
ob_clean();
				if($ok->user_login == $user){
				echo 1;
				}
				else{
				echo 0;
				}
			}//end
			
		}
		else{
			return 0;
		}
	}
	function get_category_hami( $category, $output = OBJECT, $filter = 'raw', $cat_hami ) 
	{
	    $category = get_term( $category, $cat_hami, $output, $filter );
	    if ( is_wp_error( $category ) )
	        return $category;
	 
	    _make_cat_compat( $category );
	 
	    return $category;
	}
	private function get_mainpage(){
		global $wpdb;
		$table_name = $wpdb->prefix . "hami_mainpage";
		$rec = $wpdb->get_results("select * from $table_name");
		foreach ($rec as $key ) {
			if ($key->mp_showtype == 4) {
				$slashless = stripcslashes($key->mp_value);
			}else{
				$slashless = $key->mp_value;
			}
			$array[] = array(
							"type" => $key->mp_showtype,
							"action" => $key->mp_type,
							"value" => $slashless,
							"title" => $key->mp_title,
							"pic" => $key->mp_pic,
							"order" => $key->mp_order
						);
		}
		return $array;
	}
	private function get_slider(){
		global $wpdb;
		$table_name = $wpdb->prefix . "hami_slider";
		$rec = $wpdb->get_results("select * from $table_name");
		foreach ($rec as $key ) {
			$array[] = array(
							"action" => $key->sl_type,
							"value" => $key->sl_value,
							"title" => $key->sl_title,
							"pic" => $key->sl_pic
							);
		}
		return $array;
	}
}